#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define get_long(ptr, off)	\
	((ptr[(off) + 0]) + (ptr[(off) + 1] << 8) + (ptr[(off) + 2] << 16) + (ptr[(off) + 3] << 24))

int main()
{
	unsigned char tmp[0x10];

	FILE *fi = fopen("duke3d.grp", "rb");
	fread (tmp, 0x10, 1, fi);

	if (strncmp (tmp, "KenSilverman", 12) != 0) {
		printf ("Invalid grp file!");
		return 0;
	}

	unsigned int table_entries = get_long(tmp, 0x0c);

	{
		int i;
		char file_name[13];
		memset (file_name, 0, 13);
		unsigned char *table_index = (unsigned char*)malloc(table_entries * 0x10);

		fread (table_index, table_entries * 0x10, 1, fi);

		for (i = 0; i < table_entries; i++)
		{
			memcpy (file_name, table_index + (i * 0x10), 0x0c);

			unsigned int file_size = get_long(table_index, (i * 0x10) + 0x0c);

			unsigned char *file_tmp = (unsigned char*)malloc(file_size);

			fread (file_tmp, file_size, 1, fi);

			FILE *fo = fopen(file_name, "wb");
			fwrite (file_tmp, file_size, 1, fo);
			fclose (fo);

			free (file_tmp);
		}

		free (table_index);
	}

	fclose (fi);
}
